﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;


namespace Mod
{
  public class Akisword : MonoBehaviour
  {
    public bool active = false;
    public GameObject sword;

    public void Use()
    { 
      if (!active)
      {
        foreach (var limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          limbs.Health *= 0.8f;
                        }
        active = true;
        sword = GameObject.Instantiate(ModAPI.FindSpawnable("Sword").Prefab);
        sword.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.akisword;
        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
        var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = sword.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
        sword.transform.position = transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.transform.position;
        sword.transform.rotation = transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.transform.rotation;
        sword.transform.eulerAngles += new Vector3(0, 0, 180);
        sword.gameObject.AddComponent<HingeJoint2D>();
        sword.gameObject.AddComponent<CurseSword>();
        sword.gameObject.GetComponent<HingeJoint2D>().connectedBody = transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.GetComponent<Rigidbody2D>();
        var e = ModAPI.CreateParticleEffect("Vapor", sword.gameObject.transform.position);
                e.GetComponent<ParticleSystem>().startColor = new Color(150f, 0f, 120f);
      }
      else
      {
        var e = ModAPI.CreateParticleEffect("Vapor", sword.gameObject.transform.position);
                e.GetComponent<ParticleSystem>().startColor = new Color(150f, 0f, 120f);
        active = false;
        Destroy(sword.gameObject);
        sword = null;
      }
    }
  }
  public class CurseSword : MonoBehaviour
  {
      public float Stabs = 3f;
      public TextMeshPro textComponent;
      public GameObject nameTag;
      public AudioSource audioSource;
      public GameObject Camera;
      public GameObject Canvas;
      public GameObject victim;
      public GameObject light;

      public void Update()
        {
          if (nameTag != null)
          {
            nameTag.transform.position = transform.position;
            nameTag.transform.rotation = transform.rotation;
            textComponent.text = Stabs.ToString();
          }
          if (light != null)
          {
            light.transform.eulerAngles = new Vector3(0, 0, 0);
            light.transform.Find("industrial_light_lamp").gameObject.transform.eulerAngles = new Vector3(0, 0, 0);
            light.transform.position = new Vector3(victim.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[0].gameObject.transform.position.x, victim.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[0].gameObject.transform.position.y - 12f, victim.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[0].gameObject.transform.position.z);
          }
        }

    public void Start()
    {
      nameTag = new GameObject("NameTag");
        nameTag.transform.SetParent(transform);
                textComponent = nameTag.AddComponent<TextMeshPro>();
                textComponent.text = " ";
                textComponent.fontSize = 2;
                textComponent.font = ModAPI.FindSpawnable("Thermometer").Prefab.transform.Find("Text").GetComponent<TextMeshPro>().font;
                textComponent.color = new Color(0.2f, 0f, 0.4f, 1f);
                textComponent.alignment = TextAlignmentOptions.Center;
                textComponent.horizontalAlignment = HorizontalAlignmentOptions.Center;
                textComponent.verticalAlignment = VerticalAlignmentOptions.Middle;
                audioSource = new GameObject().gameObject.AddComponent<AudioSource>();
    audioSource.transform.SetParent(transform, false);
    GameObject.FindObjectOfType<Global>().AddAudioSource(audioSource,false);
    audioSource.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.75f;
    audioSource.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
    audioSource.spatialBlend = 1;
    audioSource.volume = 1;
    Canvas = FindObjectOfType<Canvas>().gameObject;
        Camera = FindObjectOfType<Camera>().gameObject;
    }

    public void Use()
    {
      if (Stabs == 0f)
          {
            Stabs = -1000f;
            audioSource.PlayOneShot(Mod.curse0);
            StartCoroutine(rewind());
            Destroy(nameTag);
          }
    }

    public IEnumerator rewind() 
        {
          var snow2 = MapConfig.Instance.Settings.ShallowClone();
            snow2.Floodlights = false;
            snow2.Fog = true;
            snow2.Snow = true;
            snow2.Rain = false;
            MapConfig.Instance.ApplySettings(snow2);
            light = GameObject.Instantiate(ModAPI.FindSpawnable("Spot Light").Prefab);
        Destroy(light.gameObject.GetComponent<SpriteRenderer>());
        light.transform.localScale *= 2.4f;
        var l = light.transform.Find("industrial_light_lamp").gameObject;
        Destroy(l.gameObject.GetComponent<SpriteRenderer>());
        l.GetComponent<SingleFloodlightBehaviour>().Activated = true;
            light.gameObject.AddComponent<FreezeBehaviour>();
            light.gameObject.layer = 0;
          Canvas.SetActive(false);
          yield return new WaitForSeconds(2f);
          audioSource.PlayOneShot(Mod.cursea);
          GameObject Hand = new GameObject("curse");
          Hand.gameObject.AddComponent<SpriteRenderer>();
        Hand.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
        Hand.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.curse;
        Hand.gameObject.GetComponent<SpriteRenderer>().color = Color.white;
        Hand.transform.position = victim.transform.position;
        Hand.transform.localScale *= 0.05f;
        while(Hand.transform.localScale.x < 0.6f)
                        {
                          Hand.transform.localScale *= 1.01f;
                          yield return new WaitForSeconds(0.04f);
                        }
                  Hand.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                  foreach (var limbs in victim.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          limbs.BreakBone();
                          limbs.CirculationBehaviour.Cut((Vector2) limbs.transform.position, UnityEngine.Random.insideUnitCircle);
                          limbs.gameObject.GetComponent<Rigidbody2D>().AddForce(limbs.gameObject.transform.up * 2f, ForceMode2D.Impulse);
                          ModAPI.CreateParticleEffect("BloodExplosion", limbs.gameObject.transform.position);
                        }
        Destroy(Hand);
        Destroy(light);
                Canvas.SetActive(true);
                var snow = MapConfig.Instance.Settings.ShallowClone();
            snow.Floodlights = true;
            snow.Fog = false;
            snow.Snow = false;
            snow.Rain = false;
            MapConfig.Instance.ApplySettings(snow);
        }

    public void OnCollisionEnter2D(Collision2D other)
        {
          if (Stabs != 0f)
          {
            if (other.gameObject.GetComponent<PhysicalBehaviour>().IsBeingStabbed && other.gameObject.GetComponent<LimbBehaviour>())
            {
              if (Stabs == 1f)
              {
                audioSource.PlayOneShot(Mod.curse1);
              }
              else
              {
                if (Stabs == 2f)
                {
                  audioSource.PlayOneShot(Mod.curse2);
                }
                else
                {
                  audioSource.PlayOneShot(Mod.curse3);
                }
              }
              victim = other.gameObject;
              Stabs -= 1f;
            }
            }
        }
  }
}